<template>
  <div>
    <v-container>
      <p class="display-3 font-weight-light	text-center pa-4">
        Ваша корзина {{ empty }}
      </p>
      <v-row v-if="cartTotalLength">
        <v-col :cols="12" md="9" sm="12" >
          <v-simple-table>
            <template v-slot:default>
              <thead>
              <tr>
                <th class="text-left">Услуга</th>
                <th class="text-left">Цена</th>
                <th class="text-left">Удалить?</th>
              </tr>
              </thead>
              <tbody>
              <tr
                v-for="item in cart.items"
                :key="item.id"
              >
                <td>
                  <v-list-item>
                    <v-list-item-content>
                      <v-list-item-title >{{ item.title }}</v-list-item-title>
                      <v-list-item-subtitle>{{ item.description}}</v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item></td>
                <td>{{ item.price }}</td>
                <td>
                  <a @click="removeFromCart(item)">
                    <v-icon>mdi-close-circle
                    </v-icon>
                  </a>
                </td>
              </tr>
              </tbody>
            </template>
          </v-simple-table>
        </v-col>
        <v-col
          :cols="12"
          md="3" sm="12"
          style="background-color: lightgray"
        >
          <p class="headline">Order Summary</p>
          <p class="overline">
            Shipping and additional costs are calculated based on values you have entered.
          </p>
          <v-simple-table>
            <template v-slot:default>
              <tbody>
              <tr>
                <td>Подитог</td>
                <td class="text-right" style="width: 50px;">{{ subtotal }}</td>
              </tr>
              <tr>
                <td>Доставка</td>
                <td class="text-right" style="width: 50px;">{{ deliveryCost }}</td>
              </tr>
              <tr>
                <td>Налог</td>
                <td class="text-right" style="width: 50px;">{{ tax }}</td>
              </tr>
              <tr>
                <td>Всего</td>
                <td class="text-right" style="width: 50px;"><b>{{ total }}</b></td>
              </tr>
              </tbody>
            </template>
          </v-simple-table>
          <div class="text-center">
            <v-btn
              class="primary white--text mt-5"
              outlined
              @click="checkout = !checkout"
            >
              PROCEED TO PAY
            </v-btn>
          </div>
        </v-col>
      </v-row>
    </v-container>
    <v-form
      v-if="checkout"
      ref="form"
      v-model="valid"
      @submit.prevent="submitForm"
      lazy-validation
    >
      <v-container>
        <v-row>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="firstName"
              :rules="nameRules"
              label="Фамилия"
              required
            />
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="lastName"
              :rules="nameRules"
              label="Имя"
              required
            />
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="email"
              :rules="emailRules"
              label="Электронная почта"
              required
            />
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="phone"
              :counter="12"
              :rules="phoneRules"
              label="Телефон"
              required
            />
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="address"
              :rules="addressRules"
              label="Адрес"
              required
            />
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="zipcode"
              :counter="6"
              :rules="zipcodeRules"
              label="Индекс"
              required
            />
          </v-col>
          <v-btn
            :disabled="!valid"
            color="blue"
            class="mr-4"
            type="submit"
          >
            Оплатить
          </v-btn>
        </v-row>
      </v-container>
    </v-form>
    <v-container>
      <div id="card-element"></div>
    </v-container>
    <v-card  class="accent">
      <v-container>
        <v-row no-gutters>
          <v-col class="col-12 col-md-4 col-sm-12">
            <v-row >
              <v-col class="col-12 col-sm-3 pr-4 hidden-sm-only" align="right">
                <v-icon class="display-2">mdi-truck</v-icon>
              </v-col>
              <v-col class="col-12 col-sm-9 pr-4">
                <h3 class="font-weight-light">FREE SHIPPING & RETURN</h3>
                <p class="font-weight-thin">Free Shipping over $300</p>
              </v-col>
            </v-row>
          </v-col>
          <v-col class="col-12 col-md-4 col-sm-12">
            <v-row >
              <v-col class="col-12 col-sm-3 pr-4" align="right">
                <v-icon class="display-2">mdi-cash-usd</v-icon>
              </v-col>
              <v-col  class="col-12 col-sm-9 pr-4">
                <h3 class="font-weight-light">MONEY BACK GUARANTEE</h3>
                <p class="font-weight-thin">30 Days Money Back Guarantee</p>
              </v-col>
            </v-row>
          </v-col>
          <v-col class="col-12 col-md-4 col-sm-12">
            <v-row>
              <v-col class="col-12 col-sm-3 pr-4" align="right">
                <v-icon class="display-2">mdi-headset</v-icon>
              </v-col>
              <v-col  class="col-12 col-sm-9 pr-4">
                <h3 class="font-weight-light">020-800-456-747</h3>
                <p class="font-weight-thin">24/7 Available Support</p>
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </div>
</template>
<script>
import axios from "axios";

export default {
  data: () => ({
    cart: {
      items: []
    },
    deliveryCost: 300,
    checkout: false,
    valid: true,
    stripe: {},
    card: {},
    firstName: '',
    lastName: '',
    nameRules: [
      v => !!v || 'Name is required',
    ],
    email: '',
    emailRules: [
      v => !!v || 'E-mail is required',
      v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
    ],
    phone: '+7',
    phoneRules: [
      v => !!v || 'Phone is required',
      v => (v[0] === '+' ) || 'Телефон должен начинаться с символа +',
      v => (v && v.length === 12 ) || 'Phone must be contain 13 characters',
    ],
    address: '',
    addressRules: [
      v => !!v || 'Address is required',
    ],
    zipcode: '',
    zipcodeRules: [
      v => !!v || 'Zipcode is required',
      v => (v && v.length === 6 ) || 'Zipcode must be contain 6 characters',
    ],
    errors: []
  }),
  computed: {
    cartTotalLength() {
      return this.cart.items.length
    },
    empty() {
      return this.cartTotalLength ? '' : 'пуста'
    },
    subtotal() {
      return this.cart.items.reduce(
        (acc, value) => acc += value.price,
        0
      )
    },
    tax() {
      return this.subtotal * 0.2
    },
    total() {
      return this.subtotal + this.deliveryCost + this.tax
    },
    token() {
      return this.$store.getters.getToken
    },
  },
  mounted() {
    this.cart = this.$store.state.cart.cart
    this.$setTitle('Корзина')
    if (this.cartTotalLength > 0) {
      this.stripe = Stripe('pk_test_51IpzhvKCnC5Et9l6J645li7ReB9GBmktijoHxI8dhflKfYwI6OjlNqsP1ZhVIrm1u8gNWFSSXtQ0Ay9XxwoqX1Zy00D531Pxcl')
      const elements = this.stripe.elements();
      this.card = elements.create('card', { hidePostalCode: true })
      this.card.mount('#card-element')
    }
  },
  methods: {
    removeFromCart(item) {
      this.$store.commit('removeFromCart', item)
    },
    submitForm() {
      this.errors = []

      if (!this.errors.length) {
        this.$store.commit('setLoading', true)
        this.stripe.createToken(this.card).then(result => {
          if (result.error) {
            this.$store.commit('setLoading', false)
            this.errors.push('Что то пошло не так')
            console.log(result.error.message)
          } else {
            this.stripeTokenHandler(result.token)
          }
        })
      }
    },
    async stripeTokenHandler(token) {
      const items = []
      for (let i = 0; i < this.cart.items.length; i++) {
        const item = this.cart.items[i]
        const obj = {
          service: item.id,
          price: item.price
        }
        items.push(obj)
      }
      const data = {
        'first_name': this.firstName,
        'last_name': this.lastName,
        'order_email': this.email,
        'address': this.address,
        'zipcode': this.zipcode,
        'phone': this.phone,
        'items': items,
        'stripe_token': token.id,
        'paid_amount': this.total
      }
      console.log(data)
      await axios({
        method: 'post',
        data: data,
        url: `${this.$store.getters.getServerUrl}api/v1/shop/checkout/`
      })
        .then(response => {
          this.$store.commit('clearCart')
          this.$router.push('/success')
        })
        .catch(error => {
          this.errors.push('ЧТо то пошло не так')
          console.log(error)
        })
      this.$store.commit('setLoading', false)
    }
  }
}
</script>
